DCMTK - Bug #376

Possible buffer overflow in addOverrideKey()
2010-05-18 00:00 - J6rg Riesmeier

Status: Closed Start date:

Priority: High Due date:

Assignee: % Done: 0%
Category: Estimated time: 0:00 hour

Target version:
Module: dcmnet + weitere Compiler:

Operating System:

Description

http://forum.dcmtk.org/viewtopic.php?t=2523
At least the following tools are affected:

movescu
wltests
snd2dcm

'DemPath' & Co. are likely culprits.

The former ones should be done, | haven't seen a sscanf() with a "%s" in DcmPath - Uli

=== Comment Uli ===

Find all instances, where sscanf() is used with s or something else (only %s happens though): git grep sscanf | grep -E '["%"]*s'

dcmgrdb/libsrc/demgrenf.cc: if (sscanf (rcline, "%s", mnemonic) != 1) dcmgrdb/libsrc/dcmgrenf.cc: s

scanf (valueptr, "%s", value); dcmgrdb/libsrc/dcmgrcenf.cc: sscanf (valueptr, "$%$s", value);

dcmgrdb/libsrc/demgrenf.cc: sscanf (valueptr, "$s", value); dcmgrdb/libsrc/dcmgrcnf.cc: sscanf (rcli

ne, "%s %s", mnemonic, value); dcmgrdb/libsrc/dcmgrcnf.cc: sscanf (rcline, "%s %$s", mnemonic, value

)i

demgrdb/libsrc/demgrenf.cc: sscanf (rcline, "%s %s", mnemonic, value); dcmgrdb/libsrc/dcmgrcnf.cc:

sscanf (helpvalue, "%d , %s", &studies, helpval); dcmgrdb/libsrc/dcmgrtis.cc: narg = sscanf (cmdbuf,
"send %s %d", cmdarg, &iarg);

Found in dcmdata/libsrc/dcddirif.cc, dcmnet/apps/movescu.cc, dcmwlm/tests/wltests.cc und dcmwave/a

pps/snd2dcm.cc.

History

#1 - 2013-04-23 10:19 - Andrew Chiw
Possible buffer overflow in addOverrideKey()
Description

http://forum.demtk.org/viewtopic.php?t=2523
At least the following tools are affected:

movescu
wltests
snd2dcm

'DemPath’ & Co. are likely culprits.

The former should be settled, | haven't seen a sscanf() with a "%s" in DcmPath -- Ul

=== Comment Uli ===

Find all instances, where sscanf() is used with s or something else (only %s happens though): git grep sscanf | grep -E ["%"]*s'
demgrdb/libsrc/demgrent.cc: if (sscanf(rcline, "%s", mnemonic) != 1) demqgrdb/libsrc/dcmqrenf.cc: sscanf(valueptr, "%s", value);
demagrdb/libsrc/demgrenf.cc: sscanf(valueptr, "%s", value); demgrdb/libsrc/dcmqrenf.cc: sscanf(valueptr, "%s", value); demgrdb/libsrc/dcmqrenf.cc:
sscanf(rcline, "%s %s", mnemonic, value); decmqgrdb/libsrc/dcmgrenf.cc: sscanf(rcline, "%s %s", mnemonic, value); demqgrdb/libsrc/dcmarenf.cc:

sscanf(rcline, "%s %s", mnemonic, value); demgrdb/libsrc/decmagrenf.cc: sscanf(helpvalue, "%d , %s", &studies, helpval); dcmgrdb/libsrc/dcmartis.cc:
narg = sscanf(cmdbuf, "send %s %d", cmdarg, &iarg);
Found in decmdata/libsrc/dcddirif.cc, dcmnet/apps/movescu.cc, dcmwlm/tests/wltests.cc und dcmwave/apps/snd2dcm.cc.

#2 - 2016-11-24 17:44 - Marco Eichelberg

- Status changed from New to Closed

All remaining instances of sscanf with %s parameter in the toolkit were checked, dcmqrdb is the only module using doing this, however, only on a
string of known maximum size and not on an input line. Increased some buffer sizes to guarantee that no buffer overflows are possible.
Commit 22206bc thus closes this bug.

2025-10-06 22


http://www.tcpdf.org

